#ifndef __CERT
#define __CERT

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef size_t
#undef HANDLE
#define size_t unsigned long
#define HANDLE unsigned short

#undef NULL
#undef H_NULL
#define NULL ((void*)0)
#define H_NULL 0

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

typedef struct
  {
    void *Start,*Pos,*End;
    unsigned short EOF;
  } CFILE;

typedef struct
  {
    unsigned short Field;
    unsigned short HdrLen;
    unsigned long Len;
    void *Data;
  } CERT_FIELD;

#define ceof _rom_call(unsigned short,(CFILE*),128)
#define cfindfield _rom_call(unsigned short,(CFILE*,short,CERT_FIELD*),12A)
#define cgetc _rom_call(unsigned char,(CFILE*),12B)
#define cgetflen _rom_call(unsigned long,(CFILE*,short),12D)
#define cgetfnl _rom_call(long,(CERT_FIELD*),12E)
#define cgetnl _rom_call(long,(CFILE*),12F)
#define cgetns _rom_call(short,(CFILE*),130)
#define copen _rom_call(void,(CFILE*,char*,long),132)
#define copensub _rom_call(void,(CFILE*,CERT_FIELD*),133)
#define cputhdr _rom_call(unsigned short,(CFILE*,short,short),134)
#define cputnl _rom_call(void,(CFILE*,long),135)
#define cputns _rom_call(void,(CFILE*,short),136)
#define cread _rom_call(unsigned short,(CFILE*,CERT_FIELD*),137)
#define ctell _rom_call(unsigned long,(CFILE*),138)
#define cwrite _rom_call(unsigned short,(CFILE*,CERT_FIELD*),139)
#define cgetcertrevno _rom_call(unsigned short,(long*),2A0)
#define cgetsn _rom_call(void,(char*),2A1)

#ifdef DOORS

unsigned short ceof(CFILE*);
unsigned short cfindfield(CFILE*,short,CERT_FIELD*);
unsigned char cgetc(CFILE*);
unsigned long cgetflen(CFILE*,short);
long cgetfnl(CERT_FIELD*);
long cgetnl(CFILE*);
short cgetns(CFILE*);
void copen(CFILE*,char*,long);
void copensub(CFILE*,CERT_FIELD*);
unsigned short cputhdr(CFILE*,short,short);
void cputnl(CFILE*,long);
void cputns(CFILE*,short);
unsigned short cread(CFILE*,CERT_FIELD*);
unsigned long ctell(CFILE*);
unsigned short cwrite(CFILE*,CERT_FIELD*);
unsigned short cgetcertrevno(long*);
void cgetsn(char*);

#endif

#endif

