#ifndef __ESTACK
#define __ESTACK

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef HANDLE
#undef H_NULL
#undef NULL
#define HANDLE unsigned short
#define H_NULL 0
#define NULL ((void*)0)

#ifndef __BCD
#define __BCD

typedef float ti_float;

typedef struct
  {
    unsigned short exponent;
    unsigned long long mantissa;
  } bcd;

#endif

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#ifndef __ESI
#define __ESI

typedef char* ESI;

#endif

#ifndef __SCR_RECT
#define __SCR_RECT

typedef union
  {
    struct
      {
        unsigned char x0,y0,x1,y1;
      } xy;
    unsigned long l;
  } SCR_RECT;

#endif

#ifndef __WINSTRUCT
#define __WINSTRUCT

typedef struct WindowStruct
  {
    unsigned short Flags;
    unsigned char CurFont,CurAttr,Background;
    short TaskId;
    short CurX,CurY,CursorX,CursorY; 
    SCR_RECT Client,Window,Clip,Port;               
    unsigned short DupScr;
    struct WindowStruct *Next;
    char *Title;                 
  } WINDOW;

#endif

#ifndef __ESTACK_TYPES
#define __ESTACK_TYPES

#ifdef DOORS

#define top_estack _ROM_CALL_109
extern ESI top_estack;

#else

#define top_estack (*((ESI*)(*((long*)(*((long*)0xC8)+0x109*4)))))

#endif

enum Tags {VAR_NAME_TAG=0,_VAR_Q_TAG=1,VAR_R_TAG=2,VAR_S_TAG=3,VAR_T_TAG=4,
  VAR_U_TAG=5,VAR_V_TAG=6,VAR_W_TAG=7,VAR_X_TAG=8,VAR_Y_TAG=9,VAR_Z_TAG=0xA,
  VAR_A_TAG=0xB,VAR_B_TAG=0xC,VAR_C_TAG=0xD,VAR_D_TAG=0xE,VAR_E_TAG=0xF,
  VAR_F_TAG=0x10,VAR_G_TAG=0x11,VAR_H_TAG=0x12,VAR_I_TAG=0x13,VAR_J_TAG=0x14,
  VAR_K_TAG=0x15,VAR_L_TAG=0x16,VAR_M_TAG=0x17,VAR_N_TAG=0x18,VAR_O_TAG=0x19,
  VAR_P_TAG=0x1A,VAR_Q_TAG=0x1B,EXT_SYSTEM_TAG=0x1C,ARB_REAL_TAG=0x1D,
  ARB_INT_TAG=0x1E,POSINT_TAG=0x1F,NEGINT_TAG=0x20,POSFRAC_TAG=0x21,
  NEGFRAC_TAG=0x22,FLOAT_TAG=0x23,BCD_TAG=0x23,PI_TAG=0x24,EXP_TAG=0x25,
  IM_TAG=0x26,NEGINFINITY_TAG=0x27,INFINITY_TAG=0x28,PN_INFINITY_TAG=0x29,
  UNDEF_TAG=0x2A,FALSE_TAG=0x2B,TRUE_TAG=0x2C,STR_TAG=0x2D,NOTHING_TAG=0x2E,
  ACOSH_TAG=0x2F,ASINH_TAG=0x30,ATANH_TAG=0x31,COSH_TAG=0x35,SINH_TAG=0x36,
  TANH_TAG=0x37,ACOS_TAG=0x3B,ASIN_TAG=0x3C,ATAN_TAG=0x3D,RACOS_TAG=0x41,
  RASIN_TAG=0x42,RATAN_TAG=0x43,COS_TAG=0x44,SIN_TAG=0x45,TAN_TAG=0x46,
  ITAN_TAG=0x4A,ABS_TAG=0x4B,ANGLE_TAG=0x4C,CEILING_TAG=0x4D,FLOOR_TAG=0x4E,
  INT_TAG=0x4F,SIGN_TAG=0x50,SQRT_TAG=0x51,EXPF_TAG=0x52,LN_TAG=0x53,
  LOG_TAG=0x54,FPART_TAG=0x55,IPART_TAG=0x56,CONJ_TAG=0x57,IMAG_TAG=0x58,
  REAL_TAG=0x59,APPROX_TAG=0x5A,TEXPAND_TAG=0x5B,TCOLLECT_TAG=0x5C,
  GETDENOM_TAG=0x5D,GETNUM_TAG=0x5E,CUMSUM_TAG=0x60,DET_TAG=0x61,
  COLNORM_TAG=0x62,ROWNORM_TAG=0x63,NORM_TAG=0x64,MEAN_TAG=0x65,
  MEDIAN_TAG=0x66,PRODUCT_TAG=0x67,STDDEV_TAG=0x68,SUM_TAG=0x69,
  VARIANCE_TAG=0x6A,UNITV_TAG=0x6B,DIM_TAG=0x6C,MAT2LIST_TAG=0x6D,
  NEWLIST_TAG=0x6E,RREF_TAG=0x6F,REF_TAG=0x70,IDENTITY_TAG=0x71,DIAG_TAG=0x72,
  COLDIM_TAG=0x73,ROWDIM_TAG=0x74,TRANSPOSE_TAG=0x75,FACTORIAL_TAG=0x76,
  PERCENT_TAG=0x77,RADIANS_TAG=0x78,NOT_TAG=0x79,MINUS_TAG=0x7A,
  VEC_POLAR_TAG=0x7B,VEC_CYLIND_TAG=0x7C,VEC_SPHERE_TAG=0x7D,START_TAG=0x7E,
  ISTORE_TAG=0x7F,STORE_TAG=0x80,WITH_TAG=0x81,XOR_TAG=0x82,OR_TAG=0x83,
  AND_TAG=0x84,LT_TAG=0x85,LE_TAG=0x86,EQ_TAG=0x87,GE_TAG=0x88,GT_TAG=0x89,
  NE_TAG=0x8A,ADD_TAG=0x8B,ADDELT_TAG=0x8C,SUB_TAG=0x8D,SUBELT_TAG=0x8E,
  MUL_TAG=0x8F,MULELT_TAG=0x90,DIV_TAG=0x91,DIVELT_TAG=0x92,POW_TAG=0x93,
  POWELT_TAG=0x94,SINCOS_TAG=0x95,SOLVE_TAG=0x96,CSOLVE_TAG=0x97,
  NSOLVE_TAG=0x98,ZEROS_TAG=0x99,CZEROS_TAG=0x9A,FMIN_TAG=0x9B,FMAX_TAG=0x9C,
  COMPLEX_TAG=0x9D,POLYEVAL_TAG=0x9E,RANDPOLY_TAG=0x9F,CROSSP_TAG=0xA0,
  DOTP_TAG=0xA1,GCD_TAG=0xA2,LCM_TAG=0xA3,MOD_TAG=0xA4,INTDIV_TAG=0xA5,
  REMAIN_TAG=0xA6,NCR_TAG=0xA7,NPR_TAG=0xA8,P2RX_TAG=0xA9,P2RY_TAG=0xAA,
  P2PTHETA_TAG=0xAB,P2PR_TAG=0xAC,AUGMENT_TAG=0xAD,NEWMAT_TAG=0xAE,
  RANDMAT_TAG=0xAF,SIMULT_TAG=0xB0,PART_TAG=0xB1,EXP2LIST_TAG=0xB2,
  RANDNORM_TAG=0xB3,MROW_TAG=0xB4,ROWADD_TAG=0xB5,ROWSWAP_TAG=0xB6,
  ARCLEN_TAG=0xB7,NINT_TAG=0xB8,PI_PRODUCT_TAG=0xB9,SIGMA_SUM_TAG=0xBA,
  MROWADD_TAG=0xBB,ANS_TAG=0xBC,ENTRY_TAG=0xBD,EXACT_TAG=0xBE,LOGB_TAG=0xBF,
  COMDENOM_TAG=0xC0,EXPAND_TAG=0xC1,FACTOR_TAG=0xC2,CFACTOR_TAG=0xC3,
  INTEGRATE_TAG=0xC4,DIFFERENTIATE_TAG=0xC5,AVGRC_TAG=0xC6,NDERIV_TAG=0xC7,
  TAYLOR_TAG=0xC8,LIMIT_TAG=0xC9,PROPFRAC_TAG=0xCA,WHEN_TAG=0xCB,
  ROUND_TAG=0xCC,DMS_TAG=0xCD,LEFT_TAG=0xCE,RIGHT_TAG=0xCF,MID_TAG=0xD0,
  SHIFT_TAG=0xD1,SEQ_TAG=0xD2,LIST2MAT_TAG=0xD3,SUBMAT_TAG=0xD4,
  SUBSCRIPT_TAG=0xD5,RAND_TAG=0xD6,MIN_TAG=0xD7,MAX_TAG=0xD8,LIST_TAG=0xD9,
  USERFUNC_TAG=0xDA,MATRIX_TAG=0xDB,FUNC_TAG=0xDC,DATA_TAG=0xDD,GDB_TAG=0xDE,
  PIC_TAG=0xDF,TEXT_TAG=0xE0,FIG_TAG=0xE1,MAC_TAG=0xE2,EXT_TAG=0xE3,
  EXT_INSTR_TAG=0xE4,END_TAG=0xE5,COMMENT_TAG=0xE6,NEXTEXPR_TAG=0xE7,
  NEWLINE_TAG=0xE8,ENDSTACK_TAG=0xE9,PN1_TAG=0xEA,PN2_TAG=0xEB,
  ERROR_MSG_TAG=0xEC,EIGVC_TAG=0xED,EIGVL_TAG=0xEE,DASH_TAG=0xEF,
  LOCALVAR_TAG=0xF0,DESOLVE_TAG=0xF1,FDASH_TAG=0xF2,ASM_TAG=0xF3,
  ISPRIME_TAG=0xF4,OTH_TAG=0xF8,ROTATE_TAG=0xF9};

#endif

#define push_quantum _rom_call(void,(unsigned char),2EE)
#define push_quantum_pair _rom_call(void,(unsigned char,unsigned char),2EF)
#define push_parse_text _rom_call(short,(char*),3CA)
#define push_Float _rom_call(void,(float),30A)
#define push_Float_to_nonneg_int _rom_call(void,(float),30B)
#define push_string _rom_call(void,(char*),326)
#define push_Float_to_rat _rom_call(void,(ESI),30C)
#define push_round_Float _rom_call(void,(ESI),310)
#define push_END_TAG _rom_call(void,(void),263)
#define push_LIST_TAG _rom_call(void,(void),264)
#define estack_to_short _rom_call(short,(ESI,short*),2C7)
#define estack_to_ushort _rom_call(short,(ESI,short*),2C8)
#define check_estack_size _rom_call(void,(short),2C2)
#define delete_expression _rom_call(void,(ESI),2C5)
#define delete_between _rom_call(void,(ESI,ESI),2C3)
#define push_between _rom_call(void,(void*,void*),2E8)
#define next_expression_index _rom_call(ESI,(ESI),10A)
#define NG_approxESI _rom_call(void,(ESI),25C)
#define NG_rationalESI _rom_call(void,(ESI),25F)
#define NG_execute _rom_call(void,(short,short),25D)
#define HToESI _rom_call(ESI,(short),247)
#define HS_popEStack _rom_call(unsigned short,(void),244)
#define display_statements _rom_call(unsigned short,(ESI,short,short),4E)

enum ExtTags {INDIR_TAG=1,GETKEY_TAG=2,GETFOLD_TAG=3,SWITCH_TAG=4,
  UNITCONV_TAG=5,ORD_TAG=6,EXPR_TAG=7,CHAR_TAG=8,STRING_TAG=9,GETTYPE_TAG=0xA,
  GETMODE_TAG=0xB,SETFOLD_TAG=0xC,PTTEST_TAG=0xD,PXLTEST_TAG=0xE,
  SETGRAPH_TAG=0xF,SETTABLE_TAG=0x10,SETMODE_TAG=0x11,FORMAT_TAG=0x12,
  INSTRING_TAG=0x13,APPEND_TAG=0x14,DD_TAG=0x15,EXPR2DMS_TAG=0x16,
  VEC2RECT_TAG=0x17,VEC2POLAR_TAG=0x18,VEC2CYLIND_TAG=0x19,
  VEC2SPHERE_TAG=0x1A,PARENTH_START_TAG=0x1B,PARENTH_END_TAG=0x1C,
  MAT_START_TAG=0x1D,MAT_END_TAG=0x1E,LIST_START_TAG=0x1F,LIST_END_TAG=0x20,
  COMMA_TAG=0x21,SEMICOLON_TAG=0x22,COMPLEX_ANGLE_TAG=0x23,
  SINGLE_QUOTE_TAG=0x24,QUOTE_TAG=0x25,POLCPLX_TAG=0x26,TMPCNV_TAG=0x27,
  DELTA_TMPCNV_TAG=0x28,GETUNITS_TAG=0x29,SETUNITS_TAG=0x2A,BIN_TAG=0x2B,
  HEX_TAG=0x2C,INT2BIN_TAG=0x2D,INT2DEC_TAG=0x2E,INT2HEX_TAG=0x2F,
  DET_TOL_TAG=0x30,REF_TOL_TAG=0x31,RREF_TOL_TAG=0x32,SIMULT_TOL_TAG=0x33,
  GETCONFG_TAG=0x34,V_AUGMENT_TAG=0x35};

enum SysvarTags {X_BAR_TAG=1,Y_BAR_TAG=2,SIGMA_X_TAG=3,SIGMA_X2_TAG=4,
  SIGMA_Y_TAG=5,SIGMA_Y2_TAG=6,SIGMA_XY_TAG=7,SX_TAG=8,SY_TAG=9,
  SMLSIGMA_X_TAG=0xA,SMLSIGMA_Y_TAG=0xB,NSTAT_TAG=0xC,MINX_TAG=0xD,
  MINY_TAG=0xE,Q1_TAG=0xF,MEDSTAT_TAG=0x10,Q3_TAG=0x11,MAXX_TAG=0x12,
  MAXY_TAG=0x13,CORR_TAG=0x14,R2_TAG=0x15,MEDX1_TAG=0x16,MEDX2_TAG=0x17,
  MEDX3_TAG=0x18,MEDY1_TAG=0x19,MEDY2_TAG=0x1A,MEDY3_TAG=0x1B,XC_TAG=0x1C,
  YC_TAG=0x1D,ZC_TAG=0x1E,TC_TAG=0x1F,RC_TAG=0x20,THETA_C_TAG=0x21,
  NC_TAG=0x22,XFACT_TAG=0x23,YFACT_TAG=0x24,ZFACT_TAG=0x25,XMIN_TAG=0x26,
  XMAX_TAG=0x27,XSCL_TAG=0x28,YMIN_TAG=0x29,YMAX_TAG=0x2A,YSCL_TAG=0x2B,
  DELTA_X_TAG=0x2C,DELTA_Y_TAG=0x2D,XRES_TAG=0x2E,XGRID_TAG=0x2F,
  YGRID_TAG=0x30,ZMIN_TAG=0x31,ZMAX_TAG=0x32,ZSCL_TAG=0x33,EYE_THETA_TAG=0x34,
  EYE_PHI_TAG=0x35,THETA_MIN_TAG=0x36,THETA_MAX_TAG=0x37,THETA_STEP_TAG=0x38,
  TMIN_TAG=0x39,TMAX_TAG=0x3A,TSTEP_TAG=0x3B,NMIN_TAG=0x3C,NMAX_TAG=0x3D,
  PLOTSTRT_TAG=0x3E,PLOTSTEP_TAG=0x3F,ZXMIN_TAG=0x40,ZXMAX_TAG=0x41,
  ZXSCL_TAG=0x42,ZYMIN_TAG=0x43,ZYMAX_TAG=0x44,ZYSCL_TAG=0x45,ZXRES_TAG=0x46,
  Z_THETA_MIN_TAG=0x47,Z_THETA_MAX_TAG=0x48,Z_THETA_STEP_TAG=0x49,
  ZTMIN_TAG=0x4A,ZTMAX_TAG=0x4B,ZTSTEP_TAG=0x4C,ZXGRID_TAG=0x4D,
  ZYGRID_TAG=0x4E,ZZMIN_TAG=0x4F,ZZMAX_TAG=0x50,ZZSCL_TAG=0x51,
  ZEYE_THETA_TAG=0x52,ZEYE_PHI_TAG=0x53,ZNMIN_TAG=0x54,ZNMAX_TAG=0x55,
  ZPLTSTEP_TAG=0x56,ZPLTSTRT_TAG=0x57,SEED1_TAG=0x58,SEED2_TAG=0x59,
  OK_TAG=0x5A,ERRORNUM_TAG=0x5B,SYSMATH_TAG=0x5C,SYSDATA_TAG=0x5D,
  REGEQ_TAG=0x5E,REGCOEF_TAG=0x5F,TBLINPUT_TAG=0x60,TBLSTART_TAG=0x61,
  DELTA_TBL_TAG=0x62,FLDPIC_TAG=0x63,EYE_PSI_TAG=0x64,TPLOT_TAG=0x65,
  DIFTOL_TAG=0x66,ZEYE_PSI_TAG=0x67,T0_TAG=0x68,DTIME_TAG=0x69,
  NCURVES_TAG=0x6A,FLDRES_TAG=0x6B,ESTEP_TAG=0x6C,ZT0DE_TAG=0x6D,
  ZTMAXDE_TAG=0x6E,ZTSTEPDE_TAG=0x6F,ZTPLOTDE_TAG=0x70,NCONTOUR_TAG=0x71};

enum InstructionTags {CLRDRAW_ITAG=1,CLRGRAPH_ITAG=2,CLRHOME_ITAG=3,
  CLRIO_ITAG=4,CLRTABLE_ITAG=5,CUSTOM_ITAG=6,CYCLE_ITAG=7,DIALOG_ITAG=8,
  DISPG_ITAG=9,DISPTBL_ITAG=0xA,ELSE_ITAG=0xB,ENDCUSTM_ITAG=0xC,
  ENDDLOG_ITAG=0xD,ENDFOR_ITAG=0xE,ENDFUNC_ITAG=0xF,ENDIF_ITAG=0x10,
  ENDLOOP_ITAG=0x11,ENDPRGM_ITAG=0x12,ENDTBAR_ITAG=0x13,ENDTRY_ITAG=0x14,
  ENDWHILE_ITAG=0x15,EXIT_ITAG=0x16,FUNC_ITAG=0x17,LOOP_ITAG=0x18,
  PRGM_ITAG=0x19,SHOWSTAT_ITAG=0x1A,STOP_ITAG=0x1B,THEN_ITAG=0x1C,
  TOOLBAR_ITAG=0x1D,TRACE_ITAG=0x1E,TRY_ITAG=0x1F,ZOOMBOX_ITAG=0x20,
  ZOOMDATA_ITAG=0x21,ZOOMDEC_ITAG=0x22,ZOOMFIT_ITAG=0x23,ZOOMIN_ITAG=0x24,
  ZOOMINT_ITAG=0x25,ZOOMOUT_ITAG=0x26,ZOOMPREV_ITAG=0x27,ZOOMRCL_ITAG=0x28,
  ZOOMSQR_ITAG=0x29,ZOOMSTD_ITAG=0x2A,ZOOMSTO_ITAG=0x2B,ZOOMTRIG_ITAG=0x2C,
  DRAWFUNC_ITAG=0x2D,DRAWINV_ITAG=0x2E,GOTO_ITAG=0x2F,LBL_ITAG=0x30,
  GET_ITAG=0x31,SEND_ITAG=0x32,GETCALC_ITAG=0x33,SENDCALC_ITAG=0x34,
  NEWFOLD_ITAG=0x35,PRINTOBJ_ITAG=0x36,RCLGDB_ITAG=0x37,STOGDB_ITAG=0x38,
  ELSEIF_ITAG=0x39,IF_ITAG=0x3A,IFTHEN_ITAG=0x3B,RANDSEED_ITAG=0x3C,
  WHILE_ITAG=0x3D,LINETAN_ITAG=0x3E,COPYVAR_ITAG=0x3F,RENAME_ITAG=0x40,
  STYLE_ITAG=0x41,FILL_ITAG=0x42,REQUEST_ITAG=0x43,POPUP_ITAG=0x44,
  PTCHG_ITAG=0x45,PTOFF_ITAG=0x46,PTON_ITAG=0x47,PXLCHG_ITAG=0x48,
  PXLOFF_ITAG=0x49,PXLON_ITAG=0x4A,MOVEVAR_ITAG=0x4B,DROPDOWN_ITAG=0x4C,
  OUTPUT_ITAG=0x4D,PTTEXT_ITAG=0x4E,PXLTEXT_ITAG=0x4F,DRAWSLP_ITAG=0x50,
  PAUSE_ITAG=0x51,RETURN_ITAG=0x52,INPUT_ITAG=0x53,PLOTSOFF_ITAG=0x54,
  PLOTSON_ITAG=0x55,TITLE_ITAG=0x56,ITEM_ITAG=0x57,INPUTSTR_ITAG=0x58,
  LINEHORZ_ITAG=0x59,LINEVERT_ITAG=0x5A,PXLHORZ_ITAG=0x5B,PXLVERT_ITAG=0x5C,
  ANDPIC_ITAG=0x5D,RCLPIC_ITAG=0x5E,RPLCPIC_ITAG=0x5F,XORPIC_ITAG=0x60,
  DRAWPOL_ITAG=0x61,TEXT_ITAG=0x62,ONEVAR_ITAG=0x63,STOPIC_ITAG=0x64,
  GRAPH_ITAG=0x65,TABLE_ITAG=0x66,NEWPIC_ITAG=0x67,DRAWPARM_ITAG=0x68,
  CYCLEPIC_ITAG=0x69,CUBICREG_ITAG=0x6A,EXPREG_ITAG=0x6B,LINREG_ITAG=0x6C,
  LNREG_ITAG=0x6D,MEDMED_ITAG=0x6E,POWERREG_ITAG=0x6F,QUADREG_ITAG=0x70,
  QUARTREG_ITAG=0x71,TWOVAR_ITAG=0x72,SHADE_ITAG=0x73,FOR_ITAG=0x74,
  CIRCLE_ITAG=0x75,PXLCRCL_ITAG=0x76,NEWPLOT_ITAG=0x77,LINE_ITAG=0x78,
  PXLLINE_ITAG=0x79,DISP_ITAG=0x7A,FNOFF_ITAG=0x7B,FNON_ITAG=0x7C,
  LOCAL_ITAG=0x7D,DELFOLD_ITAG=0x7E,DELVAR_ITAG=0x7F,LOCK_ITAG=0x80,
  PROMPT_ITAG=0x81,SORTA_ITAG=0x82,SORTD_ITAG=0x83,UNLOCK_ITAG=0x84,
  NEWDATA_ITAG=0x85,DEFINE_ITAG=0x86,ELSE_TRY_ITAG=0x87,CLRERR_ITAG=0x88,
  PASSERR_ITAG=0x89,DISPHOME_ITAG=0x8A,EXEC_ITAG=0x8B,ARCHIVE_ITAG=0x8C,
  UNARCHIV_ITAG=0x8D,LU_ITAG=0x8E,QR_ITAG=0x8F,BLDDATA_ITAG=0x90,
  DRWCTOUR_ITAG=0x91,NEWPROB_ITAG=0x92,SINREG_ITAG=0x93,LOGISTIC_ITAG=0x94,
  CUSTMON_ITAG=0x95,CUSTMOFF_ITAG=0x96,SENDCHAT_ITAG=0x97};

#define deleted_between _rom_call(unsigned short,(ESI,ESI),2C4)
#define deleted_expression _rom_call(unsigned short,(ESI),2C6)
#define move_between_to_top _rom_call(void,(ESI,ESI),2E5)
#define moved_between_to_top _rom_call(unsigned short,(ESI,ESI),2E6)
#define min_quantum _rom_call(unsigned char,(unsigned char,unsigned char),2E4)
#define push_next_arb_int _rom_call(void,(void),2EB)
#define push_next_arb_real _rom_call(void,(void),2EC)
#define push_expr_quantum _rom_call(void,(ESI,unsigned char),2E9)
#define push_expr2_quantum _rom_call(void,(ESI,ESI,unsigned char),2EA)
#define is_free_of_tag _rom_call(unsigned short,(ESI,unsigned char),2D4)
#define reset_estack_size _rom_call(void,(short),2F3)
#define reset_control_flags _rom_call(void,(void),2F4)

#define map_unary_over_comparison _rom_call(void,(void(*)(ESI),ESI),2E3)
#define is_advanced_tag _rom_call(unsigned short,(unsigned char),2D0)
#define is_complex_number _rom_call(unsigned short,(ESI),2D2)
#define is_complex0 _rom_call(unsigned short,(ESI),2D3)
#define lead_term_index _rom_call(ESI,(ESI),2E1)
#define reductum_index _rom_call(ESI,(ESI),2F0)
#define lead_factor_index _rom_call(ESI,(ESI),2E0)
#define remaining_factors_index _rom_call(ESI,(ESI),2F1)
#define factor_base_index _rom_call(ESI,(ESI),2C9)
#define factor_exponent_index _rom_call(ESI,(ESI),2CA)
#define lead_base_index _rom_call(ESI,(ESI),2DE)
#define lead_exponent_index _rom_call(ESI,(ESI),2DF)
#define index_of_lead_base_of_lead_term _rom_call(ESI,(ESI),2CE)
#define numeric_factor_index _rom_call(ESI,(ESI),2E7)
#define index_numeric_term _rom_call(ESI,(ESI),2CD)
#define main_gen_var_index _rom_call(ESI,(ESI),2E2)
#define index_main_var _rom_call(ESI,(ESI),2CF)
#define are_expressions_identical _rom_call(unsigned short,(ESI,ESI),2BF)
#define compare_expressions _rom_call(unsigned short,(ESI,ESI),2C0)
#define is_monomial _rom_call(unsigned short,(ESI),2D9)
#define is_monomial_in_kernel _rom_call(unsigned short,(ESI),2DA)
#define is_independent_of_de_seq_vars _rom_call(unsigned short,(ESI),2D6)
#define is_tail_independent_of _rom_call(unsigned short,(ESI,ESI),2DD)
#define is_independent_of _rom_call(unsigned short,(ESI,ESI),2D5)
#define is_independent_of_tail _rom_call(unsigned short,(ESI,ESI),2D7)
#define is_independent_of_elements _rom_call(unsigned short,(ESI,ESI),2D8)
#define is_narrowly_independent_of _rom_call(unsigned short,(ESI,ESI),2DB)
#define is_antisymmetric _rom_call(unsigned short,(ESI,ESI),2D1)
#define is_symmetric _rom_call(unsigned short,(ESI,ESI),2DC)
#define re_index _rom_call(ESI,(ESI),2F2)
#define im_index _rom_call(ESI,(ESI),2CC)
#define push_next_internal_var _rom_call(void,(unsigned char),2ED)
#define GetValue _rom_call(unsigned long,(ESI,long,long),2CB)

#define push_offset_array _rom_call(unsigned short,(ESI,unsigned short**),3C4)
#define remaining_element_count _rom_call(unsigned short,(ESI),3C3)
#define is_matrix _rom_call(unsigned short,(ESI),3B7)
#define is_valid_smap_aggregate _rom_call(unsigned short,(ESI),3B9)
#define map_tail _rom_call(void,(void(*)(ESI),ESI),3BB)
#define map_tail_Int _rom_call(unsigned short,(unsigned short(*)(ESI,short),ESI,short),3BC)
#define push_list_plus _rom_call(void,(ESI,ESI),3BD)
#define push_matrix_product _rom_call(void,(ESI,ESI),3C5)
#define push_list_times _rom_call(void,(ESI,ESI),3BE)
#define push_transpose_aux _rom_call(void,(ESI,unsigned short),3C1)
#define is_square_matrix _rom_call(unsigned short,(ESI),3B8)
#define all_tail _rom_call(unsigned short,(unsigned short(*)(ESI),ESI),3B5)
#define any_tail _rom_call(unsigned short,(unsigned short(*)(ESI),ESI),3B6)
#define push_reversed_tail _rom_call(void,(ESI),3BF)
#define last_element_index _rom_call(ESI,(ESI),3BA)

#define NG_RPNToText _rom_call(unsigned short,(short,short,short),25B)
#define NG_tokenize _rom_call(unsigned short,(short,unsigned short*,unsigned short*),260)
#define NG_graphESI _rom_call(void,(ESI,short),25E)

#define Parse2DExpr _rom_call(ESI,(ESI,short),4A)
#define Print2DExpr _rom_call(void,(ESI,WINDOW*,short,short),4C)
#define Parse2DMultiExpr _rom_call(ESI,(short,short),4B)
#define Parms2D _rom_call(void,(ESI,short*,short*,short*),4D)
#define get_key_ptr _rom_call(char*,(unsigned char,unsigned char),2B7)
#define index_below_display_expression_aux _rom_call(ESI,(ESI),2B6)
#define Parse1DExpr _rom_call(unsigned short,(ESI,short,short),4F)

#define signum_Float _rom_call(long,(ESI),312)
#define compare_Floats _rom_call(long,(ESI,ESI),2F7)
#define push_overflow_to_infinity _rom_call(void,(unsigned char),30E)
#define push_pow _rom_call(void,(ESI,ESI),30F)
#define did_push_cnvrt_Float_to_integer _rom_call(short,(ESI),2F8)
#define push_cnvrt_integer_if_whole_nmb _rom_call(void,(ESI),30D)
#define compare_complex_magnitudes _rom_call(short,(ESI,ESI),2F6)
#define likely_approx_to_number _rom_call(short,(ESI),308)
#define likely_approx_to_complex_number _rom_call(short,(ESI),307)
#define should_and_did_push_approx_arg2 _rom_call(short,(ESI,ESI),311)
#define can_be_approxed _rom_call(short,(ESI,short),2F5)
#define is_Float_exact_whole_number _rom_call(short,(ESI),2FE)

/*
#define NG_setup_graph_fun _rom_call(void,(HSym,unsigned char,unsigned short*),261)
#define NG_cleanup_graph_fun _rom_call(void,(HSym,short),262)
*/

/* This macro-monstrum is created to work on any AMS version: */

#define push_internal_simplify ({register long __b=*(long*)0xC8; \
  *(void(**)(ESI))(*(long*)(__b-4)<1000?*(long*)(__b+0xE14)+22:__b+0x13E0);})

#ifdef DOORS

void push_quantum(unsigned char);
void push_quantum_pair(unsigned char,char);
short push_parse_text(char*);
void push_Float(float);
void push_Float_to_nonneg_int(float);
void push_string(char*);
void push_Float_to_rat(ESI);
void push_round_Float(ESI);
void push_END_TAG(void);
void push_LIST_TAG(void);
short estack_to_short(ESI,short*);
short estack_to_ushort(ESI,short*);
void check_estack_size(short);
void delete_expression(ESI);
void delete_between(ESI,ESI);
void push_between(void*,void*);
ESI next_expression_index(ESI);
void NG_approxESI(ESI);
void NG_rationalESI(ESI);
void NG_execute(short,short);
ESI HToESI(short);
unsigned short HS_popEStack(void);
unsigned short display_statements(ESI,short,short);

unsigned short deleted_between(ESI,ESI);
unsigned short deleted_expression(ESI);
void move_between_to_top(ESI,ESI);
unsigned short moved_between_to_top(ESI,ESI);
unsigned char min_quantum(unsigned char,unsigned char);
void push_next_arb_int(void);
void push_next_arb_real(void);
void push_expr_quantum(ESI,unsigned char);
void push_expr2_quantum(ESI,ESI,unsigned char);
unsigned short is_free_of_tag(ESI,unsigned char);
void reset_estack_size(short);
void reset_control_flags(void);

void map_unary_over_comparison(void(*)(ESI),ESI);
unsigned short is_advanced_tag(unsigned char);
unsigned short is_complex_number(ESI);
unsigned short is_complex0(ESI);
ESI lead_term_index(ESI);
ESI reductum_index(ESI);
ESI lead_factor_index(ESI);
ESI remaining_factors_index(ESI);
ESI factor_base_index(ESI);
ESI factor_exponent_index(ESI);
ESI lead_base_index(ESI);
ESI lead_exponent_index(ESI);
ESI index_of_lead_base_of_lead_term(ESI);
ESI numeric_factor_index(ESI);
ESI index_numeric_term(ESI);
ESI main_gen_var_index(ESI);
ESI index_main_var(ESI);
unsigned short are_expressions_identical(ESI,ESI);
unsigned short compare_expressions(ESI,ESI);
unsigned short is_monomial(ESI);
unsigned short is_monomial_in_kernel(ESI);
unsigned short is_independent_of_de_seq_vars(ESI);
unsigned short is_tail_independent_of(ESI,ESI);
unsigned short is_independent_of(ESI,ESI);
unsigned short is_independent_of_tail(ESI,ESI);
unsigned short is_independent_of_elements(ESI,ESI);
unsigned short is_narrowly_independent_of(ESI,ESI);
unsigned short is_antisymmetric(ESI,ESI);
unsigned short is_symmetric(ESI,ESI);
ESI re_index(ESI);
ESI im_index(ESI);
void push_next_internal_var(unsigned char);
unsigned long GetValue(ESI,long,long);

unsigned short push_offset_array(ESI,unsigned short**);
unsigned short remaining_element_count(ESI);
unsigned short is_matrix(ESI);
unsigned short is_valid_smap_aggregate(ESI);
void map_tail(void(*)(ESI),ESI);
unsigned short map_tail_Int(unsigned short(*)(ESI,short),ESI,short);
void push_list_plus(ESI,ESI);
void push_matrix_product(ESI,ESI);
void push_list_times(ESI,ESI);
void push_transpose_aux(ESI,unsigned short);
unsigned short is_square_matrix(ESI);
unsigned short all_tail(unsigned short(*)(ESI),ESI);
unsigned short any_tail(unsigned short(*)(ESI),ESI);
void push_reversed_tail(ESI);
ESI last_element_index(ESI);

unsigned short NG_RPNToText(short,short,short);
unsigned short NG_tokenize(short,unsigned short*,unsigned short*);
void NG_graphESI(ESI,short);

ESI Parse2DExpr(ESI,short);
void Print2DExpr(ESI,WINDOW*,short,short);
ESI Parse2DMultiExpr(short,short);
void Parms2D(ESI,short*,short*,short*);
char *get_key_ptr(unsigned char,unsigned char);
ESI index_below_display_expression_aux(ESI);
unsigned short Parse1DExpr(ESI,short,short);

long signum_Float(ESI);
long compare_Floats(ESI,ESI);
void push_overflow_to_infinity(unsigned char);
void push_pow(ESI,ESI);
short did_push_cnvrt_Float_to_integer(ESI);
void push_cnvrt_integer_if_whole_nmb(ESI);
short compare_complex_magnitudes(ESI,ESI);
short likely_approx_to_number(ESI);
short likely_approx_to_complex_number(ESI);
short should_and_did_push_approx_arg2(ESI,ESI);
short can_be_approxed(ESI,short);
short is_Float_exact_whole_number(ESI);

/* The following two prototypes are necessary only for pushing_ANSI_strings */

unsigned long _ROM_CALL_27E(char*);  /* strlen */
char *_ROM_CALL_26C(char*,char*);    /* strcpy */

#endif

#define push_ANSI_string(s) ({register char *__p=(s); \
  register long __l=_rom_call(long,(char*),27E)(__p); char __s[__l]; \
  __s[0]=0; push_string(_rom_call(char*,(char*,char*),26C)(__s+1,__p)+__l);})

#define push_longint ((void(*)(long))(short[]){0x4E56,0,0x48E7,0x1C04,0x2A78, \
  0xC8,0x4244,0x262E,8,0x6C10,0x4483,0x600C,0x3F03,0x206D,0xBB8,0x4E90, \
  0xE083,0x5244,0x4A83,0x66F0,0x7020,0x4AAE,8,0x6D02,0x701F,0x3E80,0x3F04, \
  0x206D,0xBBC,0x4E90,0x4CEE,0x2038,0xFFF0,0x4E5E,0x4E75})

#ifndef __FLOAT_INTERFACE
#define __FLOAT_INTERFACE

#define __BC ((float(*)())(short[]){0x4E56,-10,0x2F2E,26,0x2F2E,22,0x2F2E, \
  18,0x2F2E,14,0x2F2E,10,0x302E,8,0x2078,200,0x2070,0,0x4E90,0x202E,-10, \
  0x222E,-6,0x342E,-2,0x4E5E,0x4E75})

#define _tios_float_1(f,x,t) ((float(*)(short,t))__BC)(4*0x##f,x)
#define _tios_float_2(f,x,y,t1,t2) ((float(*)(short,t1,t2))__BC)(4*0x##f,x,y)

#endif

#define estack_number_to_Float(x) _tios_float_1(2F9,x,ESI)
#define norm1_complex_Float(x) _tios_float_1(309,x,ESI)
#define gcd_exact_whole_Floats(x,y) _tios_float_2(2FC,x,y,ESI,ESI)

#endif
