#ifndef __FLASH
#define __FLASH

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef size_t
#undef HANDLE
#define size_t unsigned long
#define HANDLE unsigned short

#undef NULL
#define NULL ((void*)0)

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#define FL_addCert _rom_call(unsigned short,(void*,long),169)
#define FL_download _rom_call(void,(long),16A)
#define FL_getCert _rom_call(void,(unsigned short*,unsigned long*,short),16C)
#define FL_getHardwareParmBlock _rom_call(void*,(void),16B)
#define FL_getVerNum _rom_call(unsigned short,(void),16D)
#define FL_write _rom_call(void,(void*,void*,long),171)

#define EM_abandon _rom_call(void,(short),15B)
#define EM_GC _rom_call(unsigned short,(short),160)
#define EM_write _rom_call(void,(void*,void*,long),167)

#define EM_survey _rom_call(void,(long*,long*,long*,long*,long*,long*),165)
#define __EM_findEmptySlot _rom_call(void*,(long,short),15F)

#ifdef DOORS

unsigned short FL_addCert(void*,long);
void FL_download(long);
void FL_getCert(unsigned short*,unsigned long*,short);
void *FL_getHardwareParmBlock(void);
unsigned short FL_getVerNum(void);
void FL_write(void*,void*,long);

void EM_abandon(short);
unsigned short EM_GC(short);
void EM_write(void*,void*,long);

void EM_survey(long*,long*,long*,long*,long*,long*);
void *__EM_findEmptySlot(long,short);

#endif

#define EM_findEmptySlot(s) __EM_findEmptySlot((s),0)

#endif
