#ifndef __MENUS
#define __MENUS

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef HANDLE
#undef NULL
#undef H_NULL
#undef CENTER
#define HANDLE unsigned short
#define NULL ((void*)0)
#define H_NULL 0
#define CENTER -1

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#ifndef __ICON
#define __ICON

typedef struct {unsigned short i[16];} ICON;
typedef unsigned short *pICON;

#endif

#define PopupNew _rom_call(unsigned short,(char*,short),45)
#define PopupAddText _rom_call(unsigned short,(short,short,char*,short),44)
#define PopupDo _rom_call(unsigned short,(short,short,short,short),47)
#define MenuPopup _rom_call(unsigned short,(void*,short,short,short),3B)
#define PopupClear _rom_call(unsigned short,(short),46)
#define PopupText _rom_call(char*,(short,short),48)

#define MenuNew _rom_call(unsigned short,(short,short,short),43)
#define MenuAddText _rom_call(short,(short,short,char*,short,short),41)
#define MenuAddIcon _rom_call(short,(short,short,void*,short,short),42)

#define MenuBegin _rom_call(unsigned short,(void*,short,short,short),36)
#define MenuKey _rom_call(short,(short,short),39)
#define MenuOn _rom_call(void,(short),3A)
#define MenuEnd _rom_call(void,(short),38)
#define MenuTopSelect _rom_call(void,(short,short),3E)
#define MenuTopStat _rom_call(void,(short,short,short),3D)
#define MenuSubStat _rom_call(void,(short,short,short),3C)

#define MenuUpdate _rom_call(void,(void),49)

enum ItemTypes {MT_TEXT=0x8000,MT_XREF=0x9000,MT_ICON=0xA000,
  MT_CASCADE=0x4000};

asm(".set MT_TEXT,0x8000");    /* Needed for usage in "asm" statements */
asm(".set MT_XREF,0x9000");
asm(".set MT_ICON,0xA000");
asm(".set MT_CASCADE,0x4000");

#define MenuCheck _rom_call(short,(short,short,short),37)
#define MenuTopRedef _rom_call(void,(short,short,short),3F)
#define MenuGetTopRedef _rom_call(unsigned short,(short,short),40)

#ifdef DOORS

unsigned short PopupNew(char*,short);
unsigned short PopupAddText(short,short,char*,short);
unsigned short PopupDo(short,short,short,short);
unsigned short MenuPopup(void*,short,short,short);
unsigned short PopupClear(short);
char *PopupText(short,short);

unsigned short MenuNew(short,short,short);
short MenuAddText(short,short,char*,short,short);
short MenuAddIcon(short,short,void*,short,short);

unsigned short MenuBegin(void*,short,short,short);
short MenuKey(short,short);
void MenuOn(short);
void MenuEnd(short);
void MenuTopSelect(short,short);
void MenuTopStat(short,short,short);
void MenuSubStat(short,short,short);

void MenuUpdate(void);

short MenuCheck(short,short,short);
void MenuTopRedef(short,short,short);
unsigned short MenuGetTopRedef(short,short);

#endif

#endif
