#ifndef __STRING
#define __STRING

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#ifndef __MEM
#define __MEM

#undef size_t
#define size_t unsigned long

#undef NULL
#define NULL ((void*)0)

#define memcpy _rom_call(void*,(void*,void*,long),26A)
#define memchr _rom_call(void*,(void*,short,long),273)
#define memmove _rom_call(void*,(void*,void*,long),26B)
#define memcmp _rom_call(short,(void*,void*,long),270)
#define memset _rom_call(void*,(void*,short,long),27C)
#define _memset _rom_call(void*,(void*,short,long),27B)

#ifdef DOORS

void *memcpy(void*,void*,long);
void *memchr(void*,short,long);
void *memmove(void*,void*,long);
short memcmp(void*,void*,long);
void *memset(void*,short,long);
void *_memset(void*,short,long);

#endif

#endif

#define strcpy _rom_call(char*,(char*,char*),26C)
#define strncpy _rom_call(char*,(char*,char*,long),26D)
#define strcat _rom_call(char*,(char*,char*),26E)
#define strncat _rom_call(char*,(char*,char*,long),26F)
#define strcmp _rom_call(short,(char*,char*),271)
#define strncmp _rom_call(short,(char*,char*,long),272)
#define strlen _rom_call(unsigned long,(char*),27E)
#define strchr _rom_call(char*,(char*,short),274)
#define strcspn _rom_call(unsigned long,(char*,char*),275)
#define strpbrk _rom_call(char*,(char*,char*),276)
#define strrchr _rom_call(char*,(char*,short),277)
#define strspn _rom_call(unsigned long,(char*,char*),278)
#define strstr _rom_call(char*,(char*,char*),279)
#define strtok _rom_call(char*,(char*,char*),27A)

#ifdef DOORS

char *strcpy(char*,char*);
char *strncpy(char*,char*,long);
char *strcat(char*,char*);
char *strncat(char*,char*,long);
short strcmp(char*,char*);
short strncmp(char*,char*,long);
unsigned long strlen(char*);
char *strchr(char*,short);
unsigned long strcspn(char*,char*);
char *strpbrk(char*,char*);
char *strrchr(char*,short);
unsigned long strspn(char*,char*);
char *strstr(char*,char*);
char *strtok(char*,char*);

#endif

#ifndef __SPRINTF
#define __SPRINTF

#define sprintf _rom_call(short,(char*,char*,...),53)
#define strerror _rom_call(char*,(short),27D)

#ifdef DOORS

short sprintf(char*,char*,...);
char *strerror(short);

#endif

#endif

#endif
