#ifndef __SYSTEM
#define __SYSTEM

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#define NeedStack _rom_call(void,(short),A4)
#define WordInList _rom_call(short,(short,short*),184)
#define OSSetSR _rom_call(void,(short),29C)
#define OSReset _rom_call(void,(void),294)
#define OSClearBreak _rom_call(void,(void),ED)
#define OSEnableBreak _rom_call(void,(void),EE)
#define OSDisableBreak _rom_call(void,(void),EF)
#define OSCheckBreak _rom_call(short,(void),EC)
#define AB_prodid _rom_call(void,(char*),29D)
#define AB_prodname _rom_call(void,(char*),29E)
#define AB_serno _rom_call(short,(char*),29F)
#define __XR_stringPtr _rom_call(char*,(long),293)
#define QSysKey _rom_call(short,(short),183)
#define QModeKey _rom_call(short,(short),182)
#define HelpKeys _rom_call(void,(void),181)
#define off _rom_call(void,(void),29A)
#define idle _rom_call(void,(void),29B)
#define OSRegisterTimer _rom_call(short,(short,long),F0)
#define OSFreeTimer _rom_call(short,(short),F1)
#define OSTimerCurVal _rom_call(unsigned long,(short),F2)
#define OSTimerExpired _rom_call(short,(short),F3)
#define OSTimerRestart _rom_call(short,(short),F4)
#define EX_patch _rom_call(void,(void*,void*),15A)

enum Timers {BATT_TIMER=1,APD_TIMER=2,LIO_TIMER=3,CURSOR_TIMER=4,
  MISC_TIMER=5,USER_TIMER=6};

typedef struct
  {
    unsigned short Head,Tail,Size,Used;
    unsigned short Buffer[0];
  } DEF_QUEUE;

#define QUEUE(s) struct {unsigned short Head,Tail,Size,Used,Buffer[s/2];}

#define kbd_queue ((void*(*)(void))(short[]){0x7006,0x4E49,0x4E75})

#define SymStoChkMem _rom_call(unsigned short,(void),295)

#define OSenqueue _rom_call(unsigned short,(short,void*),3A9)
#define OSdequeue _rom_call(unsigned short,(unsigned short*,void*),3AA)
#define OSqinquire _rom_call(unsigned short,(unsigned short*,void*),3AB)
#define OSqhead _rom_call(unsigned short,(unsigned short*,void*),3AC)
#define OSqclear _rom_call(void,(void*),3AD)

#define CU_start _rom_call(short,(void),C4)
#define CU_stop _rom_call(short,(void),C5)
#define CU_restore _rom_call(void,(short),C3)

#define CB_replaceTEXT _rom_call(short,(char*,long,short),C1)
#define CB_fetchTEXT _rom_call(short,(unsigned short*,unsigned long*),C2)

#define OSContrastUp ((void(*)(void))(long[]){0x48E71800,0x207800C8, \
  0x20680A58,0x4E904CDF,0x184E75})

#define OSContrastDn ((void(*)(void))(long[]){0x48E71800,0x207800C8, \
  0x20680A5C,0x4E904CDF,0x184E75})

#ifdef DOORS

short WordInList(short,short*);
void NeedStack(short);
void OSSetSR(short);
void OSReset(void);
void OSClearBreak(void);
void OSEnableBreak(void);
void OSDisableBreak(void);
short OSCheckBreak(void);
void AB_prodid(char*);
void AB_prodname(char*);
short AB_serno(char*);
char *__XR_stringPtr(long);
short QSysKey(short);
short QModeKey(short);
void HelpKeys(void);
void off(void);
void idle(void);
short OSRegisterTimer(short,long);
short OSFreeTimer(short);
unsigned long OSTimerCurVal(short);
short OSTimerExpired(short);
unsigned long OSTimerRestart(short);
void EX_patch(void*,void*);

unsigned short SymStoChkMem(void);

unsigned short OSenqueue(short,void*);
unsigned short OSdequeue(unsigned short*,void*);
unsigned short OSqinquire(unsigned short*,void*);
unsigned short OSqhead(unsigned short*,void*);
void OSqclear(void*);

short CU_start(void);
short CU_stop(void);
void CU_restore(short);

short CB_replaceTEXT(char*,long,short);
short CB_fetchTEXT(unsigned short*,unsigned long*);

#endif

#define XR_stringPtr(x) (*(*(unsigned long**)0xC8-1)>1000? \
  __XR_stringPtr(x):((char*(*)(short))__XR_stringPtr)(x))

#define ASM_fastcall(x) (((void(*)())(x))())

#define ASM_call(x) ({asm volatile("movem.l %d0-%d7/%a0-%a6,-(%sp)"); \
  ASM_fastcall(x); asm volatile("movem.l (%sp)+,%d0-%d7/%a0-%a6");})

#define OSVRegisterTimer ((short(*)(short,long,void(*)(void)))(short[]){0x302F,4, \
  0x5340,0xC40,2,0x6442,0xC1FC,12,0x2078,0x74,0xCA8,0x7E0,0x3396,0xFFFC, \
  0x670A,0x43FA,0x4A,0x2288,0x41FA,0x4C,0x43F0,0xE0,0xC91,-1,-1,0x661A, \
  0x22AF,6,0x236F,6,4,0x236F,10,8,0x23C8,4,0x74,0x7001,0x4E75,0x4240,0x4E75, \
  -1,-1,0,0,0,0,-1,-1,0,0,0,0,0,0,0x7E0,0x3396,0x46FC,0x2700,0x48E7,-2, \
  0x49FA,0xFFD6,0x7801,0xC94,-1,-1,0x6710,0x53AC,4,0x660A,0x2954,4,0x206C,8, \
  0x4E90,0x49EC,12,0x51CC,0xFFE2,0x4CDF,0x7FFF,0x2F3A,0xFFC4,0x4E75})

#define OSVFreeTimer ((short(*)(short))(short[]){0x302F,4,0x5340,0xC40,2,0x6432, \
  0xC1FC,12,0x2078,0x74,0xCA8,0x7E0,0x3396,0xFFFC,0x661C,0x21BC,-1,-1,0xE0, \
  0x2028,0xFFE0,0xC0A8,0xFFEC,0x5280,0x6608,0x23E8,0xFFF8,4,0x74,0x7001, \
  0x4E75,0x4240,0x4E75})

#define enter_ghost_space ((void(*)(void))(short[]){0x2078,0xC8,0xCA8,0,0x3E8, \
  -4,0x6562,0x48E7,-2,0x4FEF,0xFFEC,0x267C,3,0xE000,0x3F13,0x2F2B,2,0x2008, \
  0x280,0x60,0,0x680,2,0,0x2F40,12,0x2F40,16,0x4E4C,0x46FC,0x2700,0x760F, \
  0x2F0B,0x4267,0x41FA,0x16,0xD1FC,4,0,0x36BC,0x4EF9,0x2748,2,0x2078,0xAC, \
  0x4ED0,0x23DF,3,0xE002,0x33DF,3,0xE000,0x4FEF,0x14,0x4CDF,0x7FFF,0x205F, \
  0xD1FC,4,0,0x4ED0})

#endif
