#ifndef __TEXTEDIT
#define __TEXTEDIT

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef HANDLE
#undef size_t
#define HANDLE unsigned short
#define size_t unsigned long

#ifndef __SCR_RECT
#define __SCR_RECT

typedef union
  {
    struct
      {
        unsigned char x0,y0,x1,y1;
      } xy;
    unsigned long l;
  } SCR_RECT;

#endif

#ifndef __WINSTRUCT
#define __WINSTRUCT

typedef struct WindowStruct
  {
    unsigned short Flags;
    unsigned char CurFont,CurAttr,Background;
    short TaskId;
    short CurX,CurY,CursorX,CursorY; 
    SCR_RECT Client,Window,Clip,Port;               
    unsigned short DupScr;
    struct WindowStruct *Next;
    char *Title;                 
  } WINDOW;

#endif

#ifndef __WIN_RECT
#define __WIN_RECT

typedef struct
  {
    short x0,y0,x1,y1;
  } WIN_RECT;

#endif

#ifndef __EVENTSTRUCT
#define __EVENTSTRUCT

typedef struct EventStruct
  {
    unsigned short Type;
    unsigned short RunningApp;
    unsigned short Side;
    unsigned short StatusFlags;
    union
      {
        WINDOW *w;
        WIN_RECT *r;
        char* pasteText;
        HANDLE hPasteText;
        struct
          {
            unsigned short Mod;
            unsigned short Code;
          } Key;
      } extra;
    unsigned char StartType;
  } EVENT;

#endif

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

typedef struct TextEditStruct
  {
    WINDOW *Parent;
    unsigned short ReadOnly;
    WIN_RECT Rect;
    unsigned short BufSize;
    unsigned short CurSize;
    unsigned short CursorOffset;
    unsigned short StartOffset;
    unsigned short PreChars;
    unsigned short CharWidth;
    unsigned short CharHeight;
    unsigned short LineNum;
    unsigned short CursorX;
    unsigned short Flags;
    union
      {
        HANDLE h;
        const char *p;
      } Text;
  } TEXT_EDIT;

#define TE_checkSlack _rom_call(void,(TEXT_EDIT*),A6)
#define TE_close _rom_call(void,(TEXT_EDIT*),A5)
#define TE_empty _rom_call(void,(TEXT_EDIT*),A7)
#define TE_focus _rom_call(short,(TEXT_EDIT*),A8)
#define TE_handleEvent _rom_call(short,(TEXT_EDIT*,EVENT*),A9)
#define TE_indicateReadOnly _rom_call(void,(TEXT_EDIT*),AA)
#define TE_isBlank _rom_call(short,(TEXT_EDIT*),AB)

#define TE_open \
  _rom_call(short,(TEXT_EDIT*,WINDOW*,WIN_RECT*,short,short,short,short),AC)
#define TE_openFixed \
  _rom_call(short,(TEXT_EDIT*,WINDOW*,WIN_RECT*,char*,short,short),AD)

#define TE_pasteText _rom_call(void,(TEXT_EDIT*,char*,long),AE)
#define TE_reopen _rom_call(void,(TEXT_EDIT*,short),AF)
#define TE_reopenPlain _rom_call(void,(TEXT_EDIT*,short),B0)

#define TE_select _rom_call(void,(TEXT_EDIT*,short,short),B1)
#define TE_shrinkWrap _rom_call(void,(TEXT_EDIT*),B2)
#define TE_unfocus _rom_call(void,(TEXT_EDIT*),B3)
#define TE_updateCommand _rom_call(void,(TEXT_EDIT*,unsigned char),B4)

#ifdef DOORS

void TE_checkSlack(TEXT_EDIT*);
void TE_close(TEXT_EDIT*);
void TE_empty(TEXT_EDIT*);
short TE_focus(TEXT_EDIT*);
short TE_handleEvent(TEXT_EDIT*,EVENT*);
void TE_indicateReadOnly(TEXT_EDIT*);
short TE_isBlank(TEXT_EDIT*);

short TE_open(TEXT_EDIT*,WINDOW*,WIN_RECT*,short,short,short,short);
short TE_openFixed(TEXT_EDIT*,WINDOW*,WIN_RECT*,char*,short,short);

void TE_pasteText(TEXT_EDIT*,char*,long);
void TE_reopen(TEXT_EDIT*,short);
void TE_reopenPlain(TEXT_EDIT*,short);

void TE_select(TEXT_EDIT*,short,short);
void TE_shrinkWrap(TEXT_EDIT*);
void TE_unfocus(TEXT_EDIT*);
void TE_updateCommand(TEXT_EDIT*,unsigned char);

#endif

#endif

